# project-ideas

A simple list of project ideas that I can work on to try and add a few wrinkles onto my brain 🧠

- [ ] A simple website health checker that's basically going to be a worse version of something like StatusGator
    - This should ideally allow the user to pass in a website(s) and then we'll run checks to see if it returns a passing status code (2xx - 3xx)
    - Should ideally export Prometheus metrics
    - Should ideally be coupled with a Grafana dashboard
- [ ] Simple Go HTTP Server
    - Tinkering with project on [GitLab](https://gitlab.com/harrison.kim/simple-go-web-server)
    - This should expose a few routes that returns different responses
    - Have a cronjob try to hit miscellaneous routes to simulate live traffic
    - Expose Prometheus metrics
    - Couple with a Grafana dashboard to show the golden signals
        - Latency
        - Errors
        - Throughput
        - Saturation
- [ ] A stonk checker to view the price of a stock and create custom alerts around it
    - Tinkering with project on [GitLab](https://gitlab.com/harrison.kim/stonk-checker)
    - Visualization around Grafana would make this super easy to implement some averages and stuff
    - Set custom alarms if the price rises/falls to a certain threshold
    - Manage the Grafana dashboards using something like [grafonnet-lib](https://github.com/grafana/grafonnet-lib.git) or [grafanalib](https://github.com/weaveworks/grafanalib)
    - Potentially utilize [Alpaca Markets](https://alpaca.markets/) for their API
- [ ] Helm chart repo with [Harbor](https://github.com/goharbor/harbor)
- [ ] Do some tracing with [Jaeger](https://www.jaegertracing.io/)
- [ ] Full pipeline visualization
    - The goal of this project is to try and manage an entire system end-to-end using tools I already know and others that I aspire to learn
        - Terraform
            - manage GitLab repo
            - manage all cloud resources
        - CI
            - GitLab
            - ConcourseCI
        - CD
            - GitLab
            - ArgoCD
            - Deploy using GitOps to minimize manual endeavors
        - Kubernetes
            - Use Helm 3 to deploy to a cluster
            - Logs with Loki
